package cn.com.ctop.job.kuaishou.handler;

import cn.com.ctop.common.module.entity.CtopOauthToken;
import cn.com.ctop.common.module.service.ICtopOauthTokenService;
import cn.com.ctop.kuaishou.modules.batch.service.IKuaishouInterfaceService;
import com.xxl.job.core.context.XxlJobHelper;
import com.xxl.job.core.handler.annotation.XxlJob;
import org.jeecg.common.util.DateUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;

import java.util.List;
import java.util.concurrent.ExecutorService;
import java.util.concurrent.Executors;

@Component
public class KuaishouMaterialsLoadJob {
    @Autowired
    private ICtopOauthTokenService tokenService;
    @Autowired
    private IKuaishouInterfaceService kuaishouInterfaceService;
    static ExecutorService executorService = Executors.newFixedThreadPool(8);
    @XxlJob("kuaishouMaterials")
    public void execute() throws Exception {
        //增加接口的开始和结束日期
        String endDate = DateUtils.getNowDate("yyyy-MM-dd");
        String startDate = DateUtils.getAnotherDay("yyyy-MM-dd", endDate, -1);
        //1:查询当日数据
        List<CtopOauthToken> tokens = tokenService.selectKuaiShouToken();
        tokens.forEach(token -> executorService.submit(() -> {
            //获取全量视频素材数据
            kuaishouInterfaceService.getVideoList(token, startDate, endDate);
            // 获取图片信息数据
            kuaishouInterfaceService.getImageList(token, DateUtils.getNowDate("yyyy-MM-dd"));
        }));
        XxlJobHelper.log("快手物料数据同步完成");
    }
}
